Kerbal Space Program - Bug #5414

Decoupling creates empty ghost stage, Camera looses focus, Ship spins out of control
09/15/2015 03:35 PM - Kosmognome
Description

When decoupling parts from a rocket, it can happen that empty "ghost" stages remain behind (See Picture 1 for original staging,
Picture 2 for "ghost" stages, Picture 3 for another example of "ghost" stages).

These "ghost" stages apparently were ot correctly detached from the craft, and CoM calculations screw up, making the craft spin out
of control. This can be seen very good in picture 3-5, where the rocket moves to the top of the screen (indicating that the COM, on
which the camera focuses, moves below the rocket itself) and picture 7, where the rocket suddenly spins completely out of control. In
another instance (no screen available), the prograde marker would start jumping uncontrollable over the 8-ball, indicating a severe
bug in the calculation of the "forward" vector.

If the rocket is flown for a longer time after it spins out of control, the camera moves further and further away from it, making it almost
impossible to see the vessel at all after some time.

If needed, | can record a video of the bug happening and upload it to YT.

KSP Version: 1.0.4 (No mods at all)
0S: Win 8.1, 64-Bit

I've also attached the .craft file of the vessel in question. | have not been able to extract a minimal test case, but this vessel can be
used to repdouce the issue.

Related issues:

Related to Kerbal Space Program - Bug #2355: KSP 0.23.5 exits when staging to... Closed 04/05/2014
Related to Kerbal Space Program - Bug #2346: TR-38-D decoupler does not separ... Closed 04/04/2014
Related to Kerbal Space Program - Bug #5198: TR-38-D does not correctly decou... Closed 07/01/2015
History

#1 - 09/15/2015 03:45 PM - Kosmognome

- File ksp.log added

Here is also the relevant part of the KSP.log file.
Notably around Line 176, when Stage 9 is activated, a stack overflow occurs:

[LOG 15:39:25.278] activating stage 9 - current stage: 10

[LOG 15:39:25.279] [Size3AdvancedEngine]: Activated

[EXC 15:39:25.313] StackOverflowException: The requested operation caused a stack overflow.
Part.FindPartThroughNodes (.Part tgtPart, .Part src)

#2 - 09/16/2015 12:39 AM - RexKramer

Not sure what is going on here. The attached craft file differs from the vessel in your screenshots slightly, it has additional boosters on the side. It
causes KSP to crash to desktop when the first staging event is activated. Every time.

#3 - 09/16/2015 08:08 AM - rudi1291

OK, so, i tested this. One ghost stage occurs, because the boosters are mounted on radial decouplers. Those decouplers are in their own stage, that
never gets activated, and if you seperate the boosters together with the bottom core stage, they donA’t show up anymore.
The other problems seem to be related to bug #2355, which leeds to a CTD on linux and mac os, but not on windows. However, it still creates a
stackoverflow.

Kosmognome, can you test if the problem is solved by deleting "PhysicsSignificance = 1" from
GameData/Squad/Parts/Structural/Size3Decoupler/part.cfg as suggested in bug #2355?

#4 - 09/16/2015 09:44 AM - Kosmognhome
- File 2015-09-16_00001.jpg added

- File 2015-09-16_00003.jpg added

- File 2015-09-16_00004.jpg added

- File Saturn VI CSM LM lil.craft added

RexKramer wrote:

The attached craft file differs from the vessel in your screenshots slightly, it has additional boosters on the side.

Sorry, will upload the correct file ASAP. | tested around in order to debug the problem, and that vessel produces two ghost stages as seen in Image 3.

It causes KSP to crash to desktop when the first staging event is activated. Every time.

Not on my system. I'm on Win 8.1, 64-Bit (using the Steam version, if that's relevant), and the attached vessel only produces the stackoverflow error
that can be found in the log. After separation, the rocket moves out of the screen to the top and then starts spinning out of control.

One ghost stage occurs, because the boosters are mounted on radial decouplers.

Still, that shouldn't make the game behave weird. Furthermore, see the attached vessel, it doesn't use radial decouplers at all and still produces this
ghost staging and spinning out of control.

However, in my tests of that vessel today the spinning out of control did not happen when a ghost stage is present. See the first attached picture, you
can see that the ship moves out of the screen when stage 7 is active and starts to spin out of control. Images 2 and 3 chase and locked camera
mode, but the camera is already so far away from the vessel that it isn't even visible anymore. Navball shows the craft is completely out of control.
Except of staging, | didn't issue any inputs, so the vessel should simply fly straight up.

#5 - 09/16/2015 09:55 AM - Kosmognome
rudi1291 wrote:

Kosmognome, can you test if the problem is solved by deleting "PhysicsSignificance = 1" from
GameData/Squad/Parts/Structural/Size3Decoupler/part.cfg as suggested in bug #2355?

Ok, so I've tested this. Editing the part.cfg that way removes the ghost stages from the last attached vessel. The problem with camera moving away
and the spinning out of control is still present, thorugh. This seems to suggest that the ghost stages are not all responsible for the problem (albeit still
annoying).

#6 - 09/16/2015 01:39 PM - RexKramer
- Related to Bug #2355: KSP 0.23.5 exits when staging to TR-38-D coupler added

#7 - 09/16/2015 01:39 PM - RexKramer
- Related to Bug #2346: TR-38-D decoupler does not separate correctly added

#8 - 09/16/2015 01:39 PM - RexKramer
- Related to Bug #5198: TR-38-D does not correctly decouple with struts involved added

#10 - 09/16/2015 01:42 PM - RexKramer

The reports in #5198 and #5216 have very clear and simple reproduction steps.

#11 - 09/17/2015 01:56 AM - bv1

Are you sure that this issue should have "critical" priority? Are you really sure about that?

#12 - 09/17/2015 03:14 AM - Squelch
- Status changed from New to Need More Info

- Severity changed from Critical to Low
#13 - 09/17/2015 05:55 AM - Squelch

Due to how Unity joint strength works, a compromise had to be met with the TR-38D. This generally works, but we have found that adding struts can
have an adverse effect as seen in #5198. It is hoped that joint strength will increase as a result of changes in how Unity works which would obviate
the current situation. The TR-38D doesn't like being staged at the same time as an engine, and will be seen to stick. This stickiness, combined with
struts leaves the staging in an indeterminate state (the engine and decoupler have detached, but the struts remain connected) which has the effect of
shifting the CoM and consequential loss of control. This situation is also shown in the staging column where the bottom icon is empty.

The workaround for this situation, and probably all others that involve this decoupler, is to stage them separately. Simply move all TR-38D decouplers
to a stage preceding the next stage engine. Staging then becomes a 3 phase affair.

1. Current engine decouples from the decoupler.

2. Decoupler detaches from next stage engine.

3. New stage engine fires.
Any struts will then automatically attach to the nearest part (the part being jettisoned) and not the useful part of the craft.
| have tested your craft using the above, and can see no further issues. Please report back if you also have success.
#14 - 09/18/2015 09:47 AM - Kosmognhome
bv1 wrote:

Are you sure that this issue should have "critical" priority? Are you really sure about that?
It not for me to decide, but an issue that crashes the game on 2/3s of the plattform that can be triggered by normal gameplay easily by just using a
stock part should imho be more then low priority (or am | the only one who uses 3.75m parts?!). There is at first the NullReferenceException in the
editor that seems to be surpressed by the game which indicates a significant problem with how he game handles the data model, and may even be
connected to the later stackoverflow error in flight (in fact, i think it is very likely connected).
| have tested your craft using the above, and can see no further issues. Please report back if you also have success.

Yes and no. Change the staging so that the decoupler directly above the Cargo bay and the rokomax decoupler above that are on separate stages.
Fly straight up until fuel is burn out of the stages below the cargo hold. Use the decoupler. Normally, you would now use RCS to move a bit away from
the cargo bay, turn the CSM around, and use the Rokomax decoupler to jettison the 3.75 to 2.5 adapter. However, after using the 3.75 decoupler
above the cargo bay, the CoM again is completely wrong. activate RCS and press 'H' and the ship will move out of the camera focus and will leave
the screen to the top again. In that case, the decoupler is on it's own stage, but still exhibits very strange behavior.
I'll upload some screenshots and craft files later on.
#15 - 09/18/2015 12:17 PM - Squelch
- File Saturn VI CSM LM IlI-Fixup.craft added
Please try this fixed up version of your craft.
There is one caveat. When the S-IVB is decoupled (top 38D) the focus will be on the garaged LM, this is due to the top 38D decoupler being
reversed. Simply switch to the CM, rotate, decouple the adapter and then dock to extract the LM. This was achieved in a vertical suborbital, and

~150km circularised parking orbit.

Tip: Open the lower bay doors, disable crossflow on the payload decoupler, and button up again before launch. This ensures the fuel isn't robbed
during ascent.

#16 - 09/21/2015 01:29 PM - Kosmognome

Hallo Squelch,
this seems to work, thank you very much.

However, it kind of unsatisfying to have to drop the decouplers that way. It doesn't look good, it creates a very excessive amount of stages and it is
very inconvenient to work with. basically every craft that uses 3.75 decouplers has to be designed around their bugs, and has to be staged around
their bugs. You can't just build a rocket and it works. And I'm still not sure if | understand how | would need to stage and build another vessel with
3.75m decouplers so that | don't run into the same problem again.
Tip: Open the lower bay doors, disable crossflow on the payload decoupler, and button up again before launch. This ensures the fuel isn't
robbed during ascent.

I've replaced that with a rokomax decoupler, works much better and makes extracting the LM also a smoother process.

Anyways, thanks for your time and patience ;)

#17 - 09/21/2015 02:33 PM - Squelch
- Status changed from Need More Info to Investigating

- % Done changed from 0 to 20

No problem, and I'm pleased it worked for you.

Yes, it is awkward needing to work around the issue, and this should not be seen as a permanent solution. Therefore | have set this issue to

"Investigating” status while the problem is being worked on. It also remains visible should anyone else run into it.

#18 - 07/17/2016 09:39 AM - TriggerAu
- Status changed from Investigating to Needs Clarification

- % Done changed from 20 to 0

#19 - 07/23/2016 03:06 PM - bewing
- Status changed from Needs Clarification to Resolved

- % Done changed from 0 to 100

In ver 1.1.3, I launched the test ship with the side boosters. There were no ghost stages anymore. For some reason | had to decouple the decouplers

by hand. But the rocket basically launched properly.

(The lights on the LM were too big to fit inside the cargo bay, so the LM was stuck inside and never got out.)

Marking the issue resolved.

#20 - 10/13/2016 11:16 AM - TriggerAu

- Status changed from Resolved to Closed
